unit TechEJ1;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, QComCtrls, IniFiles, 
  libc, Qstyle, Dialogs, StdCtrls, Controls, ExtCtrls;
{$else}  
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, IniFiles, ShellAPI;
{$endif}

type
  TMain = class(TForm)
    Edit1: TEdit;
    RadioGroup1: TRadioGroup;
    Memo2: TMemo;
    Button1: TButton;
    Memo3: TMemo;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    OpenDialog: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Memo2Enter(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Memo3Enter(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    procedure LoadDictionary;
    function GetExeName: String;
    {$ifdef Linux}
    function LibcSystem(Command: String): Integer;
    {$endif}
  public
  end;

var
  Main: TMain;
  n, nr, tale:integer;
  DicName, IniFileName, dumstr: String;
  SL: TStringList;

implementation

{$R *.dfm}
//------------------------------------------------
procedure TMain.FormCreate(Sender: TObject);
var IniFile: TIniFile;
begin
  {$ifdef Linux}
  IniFileName := GetEnvironmentVariable('HOME') + '/.TechEJ.ini';
  {$else}
  IniFileName := ChangeFileExt(GetExeName, '.ini');
  {$endif}
  IniFile := TIniFile.Create(IniFileName);
  try
    with IniFile do
    begin
      DicName := ReadString('Setting', 'Name of Dictionary', ExtractFilePath(GetExeName) + 'y땨wp.dat');
    end;
  finally
    IniFile.Free;
  end;
  SL := TStringList.Create;
  {$ifdef Linux}
  Application.Style.DefaultStyle := dsWindows;
  {$else}
  Edit1.ImeMode := imClose;
  Memo2.ImeMode := imClose;
  Memo3.ImeMode := imHira;
  {$endif}
end;

procedure TMain.LoadDictionary;
var S: String;
begin
  {$ifdef Linux}
  S := '1.1';
  {$else}
  S := '1.1';
  {$endif}
  Caption := ChangeFileExt(ExtractFileName(DicName), '') + ' - TechEJ ver.' + S;
  SL.Clear;
  if FileExists(DicName) then
    SL.LoadFromFile(DicName); // t@CSMemo1ɓǂݍ
    //  for i := 1 to 10 do SL.Add('');
  n := SL.Count;
end;

procedure TMain.FormShow(Sender: TObject);
begin
  Memo2.Height := (Font.Size + 10) * 10 + 4;
  Memo3.Height := Memo2.Height;
  {$ifdef Linux}
  Height := Memo2.Top + Memo2.Height + 20;
  {$else}
  Height := Memo2.Top + Memo2.Height + 50;
  {$endif}
  LoadDictionary;
end;

procedure TMain.Edit1Change(Sender: TObject);
var
  i, j, k: Integer;
begin
  {$ifndef Linux}
  if Edit1.ImeMode = imHira then
    Radiogroup1.Itemindex := 1;
  {$endif}
  if Radiogroup1.Itemindex = 1 then
    exit;
  if Edit1.Text <> '' then
    if Length(AnsiString(Edit1.Text)) = Length(WideString(Edit1.Text)) then
    begin
      j := 0; i := -1;
      k := Length(Edit1.Text);
      while j = 0 do
      begin
        if i > SL.Count - 2 then
        begin
          ShowMessage('ɂ܂');
          Exit;
        end;
        i := i + 1;
        dumstr := Copy(SL[i], 1, k);
        j := Pos(Edit1.text, dumstr);
      end;
      Memo2.Clear;
      Memo3.Clear;
      for j := 0 to 9 do
      begin
        try
          k := Pos(':', SL[i]);
          dumstr := Copy(SL[i], 1, k - 1);
          Memo2.Lines.Add(dumstr);
          dumstr := SL[i];
          dumstr := Copy(SL[i], k + 1, Length(SL[i]) - k);
          Memo3.Lines.Add(TrimLeft(dumstr));
        except
        end;
        i := i + 1;
      end;
      tale := i - 1;
      Memo2.SelStart := 1;
      Memo3.SelStart := 1;
    end
    else
    begin
      RadioGroup1.ItemIndex := 1;
      Button1Click(Sender);
    end;
end;
//------------------------------------------------
procedure TMain.Button1Click(Sender: TObject);
var
  i, j, j2, k:integer;
begin
  Memo2.Clear;
  Memo3.Clear;
  i:= -1; k:= 0;
  while i < n-1 do
  begin
    i := i + 1;
    j := pos(Edit1.text,SL[i]);
    if j <> 0 then
    begin
      j2 := Pos(':',SL[i]);
      dumstr := Copy(SL[i], 1, j2 - 1);
      Memo2.Lines.Add(dumstr);
      dumstr := SL[i];
      dumstr := Copy(SL[i], j2 + 1, Length(SL[i])-j2);
      Memo3.Lines.Add(Trimleft(dumstr));
      k := k + 1;
    end;
    if k = 10 then
      break;
  end;
  if k = 0 then
    ShowMessage('ɂ܂');
  Edit1.SetFocus;
end;
//------------------------------------------------
procedure TMain.RadioGroup1Click(Sender: TObject);
begin
  if radiogroup1.itemindex=1 then
  begin
    {$ifndef Linux}
    Edit1.ImeMode:=imHira;
    {$endif}
    button1.enabled:=true;
    button2.enabled:=False;
    edit1.setfocus
  end
  else
  begin
    {$ifndef Linux}
    Edit1.ImeMode:=imClose;
    {$endif}
    button1.enabled:=false;
    button2.enabled:=True;
    edit1.setfocus
  end;
end;
//------------------------------------------------
procedure TMain.Button2Click(Sender: TObject);
var
  f: textfile;
  i, j: Integer;
begin
  Screen.Cursor  := crHourGlass;
  Button2.Enabled := False;
  nr := Memo2.Lines.Count;
  if nr <> 0 then
  begin
    AssignFile(f, DicName);
    Rewrite(f);
    for j := 1 to tale - 10 do
      Writeln(f, SL[j]);
    for i := 0 to nr - 1 do
      Writeln(f, Memo2.Lines[i] + ':' + Memo3.Lines[i]);
    for  j := tale + 1 to SL.Count - 1 do
      Writeln(f, SL[j]);
    Writeln(f, '');
    CloseFile (f);
    {$ifdef Linux}
    LibcSystem('chmod a+w ' + DicName);
    {$endif}
    FormCreate(sender);
    FormShow(Sender);
  end;
  Screen.Cursor :=crDefault;
end;
//------------------------------------------------
procedure TMain.Memo2Enter(Sender: TObject);
begin
  if radiogroup1.itemindex = 1 then
    exit;
  Button2.Enabled := true;
  {$ifndef Linux}
   Memo2.ImeMode := imClose;
  {$endif}
end;
//------------------------------------------------
procedure TMain.Memo3Enter(Sender: TObject);
begin
  if radiogroup1.itemindex = 1 then exit;
  Button2.Enabled :=true;
end;
//------------------------------------------------
procedure TMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SL.Free;
end;
//------------------------------------------------
procedure TMain.Button3Click(Sender: TObject);
{$ifdef Linux}
var S: String;
{$endif}
begin
{$ifdef Linux}
  S := ExtractFilePath(GetExeName) + 'Help.htm';
  LibcSystem('netscape ' + S);
  if LibcSystem('kfmclient openURL "' + S + '"') = -1 then
    if LibcSystem('mozilla ' + S) = -1 then
      if LibcSystem('netscape ' + S) = -1 then
        ShowMessage('Sorry, cannot open a browser.');
{$else}
  ShellExecute(Handle, 'open', PChar(ExtractFileDir(GetExeName) + '\Help.htm'), nil, PChar(ExtractFileDrive(GetExeName)), SW_SHOW);
{$endif}
end;
//----------------------------------------------------------
procedure TMain.Button4Click(Sender: TObject);
var
  i: Integer;
  dumstr2: String;
begin
  dumstr := '';
  dumstr := InputBox('VKo^', 'pP͂Ă', dumstr);
  if dumstr <> '' then
  begin
    for i := 1 to 44 - Length(dumstr) do
      dumstr := dumstr + ' ';
    dumstr2 := '';
    dumstr2 := InputBox('VKo^', '{͂ĂB', dumstr2);
    if dumstr2 <> '' then
    begin
      dumstr := dumstr + dumstr2;
      SL.Add(dumstr);
      SL.Sort;
      SL.SaveToFile(DicName);
      {$ifdef Linux}
      LibcSystem('chmod a+w ' + DicName);
      {$endif}
    end;
  end;
end;

procedure TMain.Button5Click(Sender: TObject);
var IniFile: TIniFile;
begin
  with OpenDialog do
  begin
    InitialDir := ExtractFileDir(GetExeName);
    if Execute then
      DicName := FileName;
  end;
  IniFile := TIniFile.Create(IniFileName);
  try
    with IniFile do
    begin
      EraseSection('Setting');
      WriteString('Setting', 'Name of Dictionary', DicName);
      UpdateFile;
      {$ifdef Linux}
      LibcSystem('chmod a+w ' + ChangeFileExt(GetExeName, '.ini'));
      {$endif}
    end;
  finally
    IniFile.Free;
  end;
  Edit1.SetFocus;
  LoadDictionary;
end;

{$ifdef Linux}
function TMain.LibcSystem(Command: String): Integer;
var
  Str: array [0..250] of char;
begin
  StrPlCopy(Str, Command, 250);
  Result := Libc.system(Str);
end;
{$endif}

function TMain.GetExeName: String;
{$ifdef Linux}
var
  buffer: array [0..MAX_PATH] of Char;
  length: Integer;
{$endif}
begin
{$ifdef Linux}
  length := readlink('/proc/self/exe', buffer, MAX_PATH);
  if length > -1 then
    SetString(Result, buffer, length)
  else
    RaiseLastOSError;
{$else}
  Result := Application.ExeName;
{$endif}
end;
end.
