unit TranslationForm; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Grids,
  Buttons, Clipbrd, MainForm;

type

  { TTranslation }

  TTranslation = class(TForm)
    btnTranslate: TButton;
    btnClose: TButton;
    btnMoveLeft: TButton;
    StringGrid: TStringGrid;
    btnMoveRight: TButton;
    procedure StringGridSelectCell(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure btnCloseClick(Sender: TObject);
    procedure btnTranslateClick(Sender: TObject);
    procedure tnMoveLeftClick(Sender: TObject);
    procedure SwapCell(j: Integer);
    procedure tnMoveRightClick(Sender: TObject);
  private
    procedure SetToClipboard;
  public
    { public declarations }
  end; 

var
  Translation: TTranslation;
  S: String;

implementation

{ TTranslation }

procedure TTranslation.SetToClipboard;
var
  i: Integer;
begin
  S := '';
  for i := 0 to 7 do
    S :=  S + StringGrid.Cells[i,0] + ' ';
  Clipboard.AsText := S;
end;

procedure TTranslation.btnTranslateClick(Sender: TObject);
var
  i, j, k: Integer;
  Se, Sj: String;
  ReplacedWord: TStringList;
begin
  ReplacedWord := TStringList.Create;
  try
    S := Clipboard.AsText;
    for i := 0 to Main.SL.Count - 1 do
    begin
      j := Pos(':', Main.SL[i]);
      Se := Copy(Main.SL[i], 1, j - 1);
      k := Pos(Se, S);
      if k > 0 then
      begin
        Sj := Copy(Main.SL[i], j + 1, Length(Main.SL[i]) - j);
        Se := IntToStr(k);
        while Length(Se) < 3 do
          Se := '0' + Se;
        ReplacedWord.Add(Se + Sj);
      end;
    end;
    ReplacedWord.Sort;
    for i := 0 to ReplacedWord.Count - 1 do
      StringGrid.Cells[i,0] := Copy(ReplacedWord[i], 4, 100);
    SetToClipboard;
  finally
    ReplacedWord.Free;
  end;
end;

procedure TTranslation.tnMoveLeftClick(Sender: TObject);
begin
  SwapCell(-1);
end;

procedure TTranslation.tnMoveRightClick(Sender: TObject);
begin
  SwapCell(1);
end;

procedure TTranslation.SwapCell(j: Integer);
var i: Integer;
begin
  i := StringGrid.Col;
  S := StringGrid.Cells[i+j,0];
  StringGrid.Cells[i+j,0] := StringGrid.Cells[i,0];
  StringGrid.Cells[i,0] := S;
  StringGrid.Col := i + j;
  SetToClipboard;
end;

procedure TTranslation.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TTranslation.StringGridSelectCell(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
begin
  if Col = 0  then
    btnMoveLeft.Enabled := False
  else
    btnMoveLeft.Enabled := True;
  if Col = 7  then
    btnMoveRight.Enabled := False
  else
    btnMoveRight.Enabled := True;
end;

initialization
  {$I TranslationForm.lrs}

end.

